petsc-3.10.5 2019-03-28
Report Typos and Errors

# MatCreateSeqBAIJ

Creates a sparse matrix in block AIJ (block compressed row) format. For good matrix assembly performance the user should preallocate the matrix storage by setting the parameter nz (or the array nnz). By setting these parameters accurately, performance during matrix assembly can be increased by more than a factor of 50.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode  MatCreateSeqBAIJ(MPI_Comm comm,PetscInt bs,PetscInt m,PetscInt n,PetscInt nz,const PetscInt nnz[],Mat *A)

Collective on MPI_Comm

### Input Parameters

| comm | - MPI communicator, set to PETSC_COMM_SELF
| bs | - size of block, the blocks are ALWAYS square. One can use MatSetBlockSizes() to set a different row and column blocksize but the row blocksize always defines the size of the blocks. The column blocksize sets the blocksize of the vectors obtained with MatCreateVecs()
| m | - number of rows
| n | - number of columns
| nz | - number of nonzero blocks per block row (same for all rows)
| nnz | - array containing the number of nonzero blocks in the various block rows (possibly different for each block row) or NULL

### Output Parameter

A -the matrix

It is recommended that one use the MatCreate(), MatSetType() and/or MatSetFromOptions(), MatXXXXSetPreallocation() paradgm instead of this routine directly. [MatXXXXSetPreallocation() is, for example, MatSeqAIJSetPreallocation]

### Options Database Keys

-mat_no_unroll -uses code that does not unroll the loops in the block calculations (much slower)
-mat_block_size -size of the blocks to use

### Notes

The number of rows and columns must be divisible by blocksize.

If the nnz parameter is given then the nz parameter is ignored

A nonzero block is any block that as 1 or more nonzeros in it

The block AIJ format is fully compatible with standard Fortran 77 storage. That is, the stored row and column indices can begin at either one (as in Fortran) or zero. See the users' manual for details.

Specify the preallocated storage with either nz or nnz (not both). Set nz=PETSC_DEFAULT and nnz=NULL for PETSc to control dynamic memory allocation. See Users-Manual: ch_mat for details. matrices.

### See Also

MatCreate(), MatCreateSeqAIJ(), MatSetValues(), MatCreateBAIJ()

### Level

intermediate

### Location

src/mat/impls/baij/seq/baij.c

### Examples

src/tao/unconstrained/examples/tutorials/rosenbrock1.c.html
src/tao/unconstrained/examples/tutorials/rosenbrock1f.F90.html
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages